/***
    Copyright (C) 2013 Julien Spautz <spautz.julien@gmail.com>

    This program or library is free software; you can redistribute it
    and/or modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 3 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General
    Public License along with this library; if not, write to the
    Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301 USA.
***/

public Switchboard.Plug get_plug (Module module) {
    debug ("Activating Startup Apps plug");
    return new Pantheon.Startup.Plug ();
}

public class Pantheon.Startup.Plug : Switchboard.Plug {

    Controller controller;

    public Plug () {
        Object (category: Category.PERSONAL,
                code_name: "personal-pantheon-startup",
                display_name: _("Startup Apps"),
                description: _("Manage apps that run at startup"),
                icon: "preferences-system-session");

        Backend.KeyFileFactory.init ();
    }

    public override Gtk.Widget get_widget () {
        if (controller == null) {
            var monitor = new Backend.Monitor ();
            var view = new Widgets.Scrolled ();
            view.show_all ();
            controller = new Controller (view, monitor);
        }
        
        return controller.view as Gtk.Widget;
    }

    public override void shown () {
    }

    public override void hidden () {
    }

    public override void search_callback (string location) {
    }

    public override async Gee.TreeMap <string, string> search (string search) {
        return new Gee.TreeMap <string, string> (null, null);
    }
}
